<template>
  <div :class="`as-card-item ${freezeCards ? 'freeze' : ''}`">
    <div class="toggle-card">
      <el-button type="text" @click="toggleShowInfo">
        <AsIcon :name="!isShowInfo ? 'eye-show' : 'eye-hide'" />
        {{ !isShowInfo ? 'Show card number' : 'Hide card number' }}
      </el-button>
    </div>
    <div class="as-card" :style="{ 'background-color': backgroundColor }">
      <div class="as-card__logo">
        <img
          :src="require('@/assets/images/aspire-logo.svg')"
          alt="Aspire logo"
        />
      </div>
      <div class="as-card__name">{{ cardName }}</div>
      <div class="as-card__number">
        <div
          class="as-card__number-item"
          v-for="(item, index) in convertCardNumber"
          :key="item"
        >
          <div v-if="!isShowInfo && index !== 3" class="as-card__dots">
            <span v-for="n in 4" :key="n" class="as-card__dots__item" />
          </div>
          <span v-else>{{ item }}</span>
        </div>
      </div>
      <div class="as-card__private">
        <div class="as-card__expire">Thru: {{ expire }}</div>
        <div class="as-card__cvv">
          CVV:
          <span :class="!isShowInfo ? 'star-instead' : ''">{{
            !isShowInfo ? '***' : cvv
          }}</span>
        </div>
      </div>
      <div class="as-card__logo">
        <img :src="require('@/assets/images/visa-logo.svg')" alt="Visa logo" />
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
export default {
  name: 'CardItem',
  props: {
    id: {
      type: String,
      default: Math.random().toString(),
    },
    cardName: {
      type: String,
      default: '',
    },
    cardNumber: {
      type: String,
      default: '',
    },
    expire: {
      type: String,
      default: '',
    },
    cvv: {
      type: Number,
      default: 123,
    },
    backgroundColor: {
      type: String,
      default: '#01d167',
    },
  },
  computed: {
    ...mapGetters('card', ['freezeCards']),
    convertCardNumber() {
      return [
        this.cardNumber.slice(0, 4),
        this.cardNumber.slice(4, 8),
        this.cardNumber.slice(8, 12),
        this.cardNumber.slice(12, 16),
      ];
    },
  },
  data: () => {
    return {
      isShowInfo: false,
    };
  },
  methods: {
    toggleShowInfo() {
      this.isShowInfo = !this.isShowInfo;
    },
  },
};
</script>

<style lang="scss">
.as-card-item {
  flex: 1;
  display: flex;
  flex-direction: column;
  &.freeze {
    opacity: 0.6;
    pointer-events: none;
  }
}
.toggle-card {
  display: flex;
  justify-content: flex-end;
  align-items: center;
  .el-button {
    height: 40px;
    width: 151px;
    font-size: 12px;
    padding: 6px 10px;
    padding-bottom: 18px;
    color: $-green;
    background-color: $-white;
  }
  .as-icon {
    margin-right: 6px;
  }
}
.as-card {
  max-width: 358px;
  max-height: 230px;
  width: 100%;
  height: 100%;
  padding: 24px;
  background-color: $-green;
  border-radius: 12px;
  color: $-white;
  font-weight: bold;
  margin-top: -12px;
  flex: 1;
  .star-instead {
    height: 24px;
    font-size: 24px;
    font-weight: bold;
    line-height: 1;
    margin-left: 5px;
  }
  &__logo {
    display: flex;
    justify-content: flex-end;
    align-items: center;
  }
  &__name {
    font-size: 22px;
    padding-top: 20px;
    @include align-left;
  }
  &__number {
    display: flex;
    align-items: center;
    padding-top: 25px;
    padding-bottom: 15px;
    @include align-left;
  }
  &__number-item {
    font-size: 14px;
    margin-left: 24px;
    @include letter-spacing;
    &:first-child {
      margin-left: 0;
    }
  }
  &__private {
    display: flex;
    align-items: center;
    margin-bottom: 5px;
  }
  &__cvv {
    display: flex;
    align-items: flex-start;
    height: 20px;
    margin-left: 29px;
    @include letter-spacing;
  }
  &__dots {
    display: flex;
    &__item {
      display: block;
      width: 8px;
      height: 8px;
      background-color: $-white;
      border-radius: 50%;
      margin-left: 5px;
      &:first-child {
        margin-left: 0;
      }
    }
  }
}
</style>
